%define	base_name	xsw
%define	major_version	1.40
%define	name		%{base_name}%{major_version}
%define	version		1.40.5
%define release		5mdk
%define branch		(unstable version)
%define summary		The XShipWars kickass game ! %{branch}
%define summary_server	XShipWars universe server %{branch}
%define summary_monitor	XShipWars universe monitor %{branch}
%define summary_unvedit	XShipWars universe editor %{branch}
%define clientdir	%{_datadir}/games/xshipwars
%define serverdatadir	%{_localstatedir}/swserv%{major_version}
%define serverconfdir	%{_sysconfdir}/swserv%{major_version}
%define serverlogdir	/var/log/swserv%{major_version}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	%{summary}
License: 	GPL
Group: 		Games/Other
Source0:	http://www.battlefieldlinux.com/download/%{base_name}-%{version}.tar.bz2
Source1:	%{base_name}.server.script.tar.bz2
Source2:	%{base_name}.icons.tar.bz2
Source3:	%{name}.blitstd.tar.bz2
Patch0:		%{name}.server.conf.patch.bz2
Patch1:		%{base_name}.monitor.patch.bz2
Url: 		http://wolfpack.twu.net/ShipWars/XShipWars
Requires:	xsw-data xsw-images xsw-sounds
BuildRequires:	libjsw1-devel libY2-devel libesound0-devel libxpm4-devel libdb3.3-devel
BuildRoot:	%{_tmppath}/%{name}-buildroot
Obsoletes:	%{base_name}
Provides:	%{base_name}

%description
XShipWars is a highly customizable and massively multiplayer space
gaming system designed for play entirly over the Internet.
It is the first completed and stable game for Linux written on Linux and
has been ported to a variety of other platforms.

%package monitor
Group: 		Games/Other
Summary: 	%{summary_monitor}
Requires:	xsw-data-monitor
Obsoletes:	%{base_name}-monitor
Provides:	%{base_name}-monitor

%description monitor
This is the universe monitor part of XShipWars game.

%package unvedit
Group: 		Games/Other
Summary: 	%{summary_unvedit}
Requires:	xsw-data-unvedit
Obsoletes:	%{base_name}-unvedit
Provides:	%{base_name}-unvedit

%description unvedit
This is the universe editor part of XShipWars game.

%package server
Group: 		Games/Other
Summary:	%{summary_server}
Obsoletes:	%{base_name}-server
Provides:	%{base_name}-server

%description server
This is the server part of XShipWars game.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -n %{base_name}-%{version}
%setup -n %{base_name}-%{version} -T -D -a1
%setup -n %{base_name}-%{version} -T -D -a2
%setup -n %{base_name}-%{version} -T -D -a3
%patch0
%patch1
(cd unvedit && ln -s ../client/mathutil.h .)
(cd unvedit && ln -s ../client/rect.h .)

%build
%configure
%define build_opts "CFLAGS = -D__USE_BSD -DUSE_XSHM -DJS_SUPPORT -DHAVE_YIFF -DHAVE_ESD $(echo $RPM_OPT_FLAGS | sed -e s/-fno-exceptions/-fexceptions/)"
make client_linux %{build_opts}
make server_linux %{build_opts}
make monitor_linux %{build_opts}
make unvedit_linux %{build_opts}

%install
make client_install_unix PREFIX=$RPM_BUILD_ROOT%{_prefix}
make monitor_install_unix PREFIX=$RPM_BUILD_ROOT%{_prefix}
make unvedit_install_unix PREFIX=$RPM_BUILD_ROOT%{_prefix}
# custom server installation
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/init.d
install -d -m 755 $RPM_BUILD_ROOT%{_sbindir}
install -d -m 755 $RPM_BUILD_ROOT%{serverconfdir}
install -d -m 755 $RPM_BUILD_ROOT%{serverlogdir}
install -d -m 755 $RPM_BUILD_ROOT%{serverdatadir}/db
install -d -m 755 $RPM_BUILD_ROOT%{serverdatadir}/plugins
install -m 755 bin/init $RPM_BUILD_ROOT%{_sysconfdir}/init.d/swserv%{major_version}
install -m 755 server/swserv $RPM_BUILD_ROOT%{_sbindir}/swserv%{major_version}
install -m 644 server/default.conf $RPM_BUILD_ROOT%{serverconfdir}
install -m 644 server/generic_in.unv $RPM_BUILD_ROOT%{serverdatadir}/db
install -m 644 server/default.ocs $RPM_BUILD_ROOT%{serverdatadir}/db
install -m 644 server/default.opm $RPM_BUILD_ROOT%{serverdatadir}/db
# script versionning
perl -pi -e 's/^(.*=.*\/swserv)$/${1}%{major_version}/' $RPM_BUILD_ROOT%{_sysconfdir}/init.d/swserv%{major_version}
# files versionning
for file in $RPM_BUILD_ROOT%{_gamesbindir}/* $RPM_BUILD_ROOT%{clientdir}/etc/*; do
	mv $file $file"%{major_version}"
done
# icons
install -D -m 644 %{base_name}_48x48.xpm $RPM_BUILD_ROOT%{_liconsdir}/%{name}.xpm 
install -D -m 644 %{base_name}_32x32.xpm $RPM_BUILD_ROOT%{_iconsdir}/%{name}.xpm 
install -D -m 644 %{base_name}_16x16.xpm $RPM_BUILD_ROOT%{_miconsdir}/%{name}.xpm 
install -D -m 644 %{base_name}-monitor_48x48.xpm $RPM_BUILD_ROOT%{_liconsdir}/%{name}-monitor.xpm 
install -D -m 644 %{base_name}-monitor_32x32.xpm $RPM_BUILD_ROOT%{_iconsdir}/%{name}-monitor.xpm 
install -D -m 644 %{base_name}-monitor_16x16.xpm $RPM_BUILD_ROOT%{_miconsdir}/%{name}-monitor.xpm 
install -D -m 644 %{base_name}-unvedit_48x48.xpm $RPM_BUILD_ROOT%{_liconsdir}/%{name}-unvedit.xpm 
install -D -m 644 %{base_name}-unvedit_32x32.xpm $RPM_BUILD_ROOT%{_iconsdir}/%{name}-unvedit.xpm 
install -D -m 644 %{base_name}-unvedit_16x16.xpm $RPM_BUILD_ROOT%{_miconsdir}/%{name}-unvedit.xpm 

# menu entry
mkdir -p $RPM_BUILD_ROOT%{_libdir}/menu
cat >$RPM_BUILD_ROOT%{_menudir}/%{name} <<EOF
?package(%{name}):\\
	command="%{_gamesbindir}/xsw%{major_version}"\\
	needs="X11"\\
	icon="%{name}.xpm"\\
	section="Amusement/Other"\\
	title="XShipWars" \
	longtitle="%{summary}"
EOF
cat >$RPM_BUILD_ROOT%{_menudir}/%{name}-monitor <<EOF
?package(%{name}-monitor):\\
	command="%{_gamesbindir}/monitor%{major_version}"\\
	needs="X11"\\
	icon="%{name}-monitor.xpm"\\
	section="Amusement/Other"\\
	title="Monitor" \
	longtitle="%{summary_monitor}"
EOF
cat >$RPM_BUILD_ROOT%{_menudir}/%{name}-unvedit <<EOF
?package(%{name}-unvedit):\\
	command="%{_gamesbindir}/unvedit%{major_version}"\\
	needs="X11"\\
	icon="%{name}-unvedit.xpm"\\
	section="Amusement/Other"\\
	title="Unvedit" \
	longtitle="%{summary_unvedit}"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{update_menus}

%postun
%{clean_menus}

%post monitor
%{update_menus}

%postun monitor
%{clean_menus}

%post unvedit
%{update_menus}

%postun unvedit
%{clean_menus}

%post server
# add swserv service
chkconfig --add swserv%{major_version}

%preun server
# stop swserv if running
if [ -f /var/lock/subsys/swserv%{major_version} ]; then
	%{_sysconfdir}/init.d/swserv%{major_version} stop
fi
# remove swserv service
chkconfig --del swserv%{major_version}

%files 
%defattr(-,root,root)
%doc CREDITS INSTALL LICENSE README TODO
%{_gamesbindir}/xsw%{major_version}
%{clientdir}/etc/*
%{_menudir}/%{name}
%{_miconsdir}/%{name}.xpm
%{_iconsdir}/%{name}.xpm
%{_liconsdir}/%{name}.xpm

%files monitor
%defattr(-,root,root)
%{_gamesbindir}/monitor%{major_version}
%{_menudir}/%{name}-monitor
%{_miconsdir}/%{name}-monitor.xpm
%{_iconsdir}/%{name}-monitor.xpm
%{_liconsdir}/%{name}-monitor.xpm

%files unvedit
%defattr(-,root,root)
%{_gamesbindir}/unvedit%{major_version}
%{_menudir}/%{name}-unvedit
%{_miconsdir}/%{name}-unvedit.xpm
%{_iconsdir}/%{name}-unvedit.xpm
%{_liconsdir}/%{name}-unvedit.xpm

%files server
%defattr(-,root,root)
%config(noreplace) %{serverconfdir}
%config(noreplace) %{_sysconfdir}/init.d/*
%{_sbindir}/*
%attr(-,games,games) %{serverdatadir}
%attr(-,games,games) %{serverlogdir}

%changelog
* Sat Oct 27 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.40.5-5mdk
- buildrequires libdb3.3-devel
- used games user instead of specific user
- rewrote init script
- obsoletes xsw

* Sat Oct 20 2001 Guillaume Rousse <g.rousse@linux-mandrake.          -
- corrected a bug in server %pre

* Tue Oct 09 2001 Lenny Cartier <lenny@mandrakesoft.com> 1.40.5-3mdk
- fixes by Guillaume Rousse <g.rousse@linux-mandrake.com> :
	- changed name to xsw%{major_version} for unstable branch
	- monitor and unvedit data files now in external packages
	- completly reworked server package (aka: before it couldn't run, now it could)
	- changed summary
	- s/Copyright/License
	- truncated description to 72 columns
	- spec cleanup
	- more menus
	- icons in right dir

* Tue Apr 24 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.40.5-2mdk
- really 1.40.5
- 16bpp patch
- split data, image and sound into distinct packages

* Mon Apr 23 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.40.5-1mdk
- 1.40.5
- update requires and buildrequires

* Fri Apr 13 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.40.4-1mdk
- buildrequires libjsw-devel libY2-devel esound-devel libxpm-devel
- 1.40.4

* Wed Mar 07 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.40.3-1mdk
- 1.40.3

* Sun Feb 18 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.40.2-1mdk
- first Mandrake release
